@echo off

REM --------------------------------------------------------
REM SourceSafe repository backup script v0.1
REM (c) Neokobe.nl (info@neokobe.nl) May 2004

REM =================

REM This file may only be distributed through www.neokobe.nl !

REM If you downloaded or obtained this file otherwise, please
REM notify me at info@neokobe.nl

REM Thanks!

REM =================

REM The use of this file is FREE!

REM =================

REM NO WARRANTY WHATSOEVER IS GIVEN! USE AT YOUR OWN RISK!
  
REM THE AUTHOR WILL NOT BE HELD RESPONSIBLE FOR ANY DAMAGES

REM WHATSOEVER. NEVER USE THIS SCRIPT WITHOUT ANY OTHER FORM
  
REM OF BACKUP. BE SAFE, NOT SORRY!

REM --------------------------------------------------------

REM Usage:
REM      Put this script in your SourceSafe win32 directory
REM      and edit the global variabeles below to match
REM      your situation.
REM      Open the user directory of the ssuser you entered
REM	 below. This directory can be found inside the
REM	 SourceSafe directory (ssdir). Open the ss.ini file
REM 	 and ADD the following line:
REM	     Force_Dir = Yes
REM	 Test this script by running it manually one time.
REM	 If you're satisfied, then schedule it by using
REM	 the standard Windows scheduler.


REM Global variabeles:

REM      ssuser = A SourceSafe user with read rights.
REM		  This user must exist in the /users 
REM		  directory of SourceSafe

REM	 sspass = The password of the ssuser.
REM		  Leave blank if no password is set.

REM	 ssdir  = The directory where your ssafe.ini resides
REM		  i.e. \\myserver\tracker or c:\sourcesafe\

REM	 ssbakd = The directory where you want the files
REM		  from SourceSafe to be written to.

REM	 ssmail = The emailaddress where you'd like to 
REM		  receive reports. Useful when you've
REM		  scheduled this script on a remote server.
REM		  Leave blank if you don't want to use this.

REM	 smtp   = IP or domainname of your SMTP server.
REM		  Leave blank if you don't want to use this.
REM --------------------------------------------------------

SET ssuser=yourname
SET sspass=yourpass
SET ssdir=c:\yourvssdir
SET ssbakd=c:\backupdir
SET ssmail=youremail@yourdomain.com
SET smtp=yourstmpserver

FOR /F "tokens=1 delims=" %%t in ('CD') DO @SET thisDir=%%t

REM --------------------------------------------------------
REM Set DATE variabele to dd/mm/yyyy format
REM --------------------------------------------------------
FOR /F "tokens=2-4 delims=/ " %%i IN ('date /t') DO SET DATE=%%j-%%i-%%k

REM --------------------------------------------------------
REM Start outputting to log
REM --------------------------------------------------------

@echo %time%: Starting backup
@echo ======================================================= > "sourcesafe_%DATE%_log.txt"
@echo SourceSafe repository backup script v0.1 >> "sourcesafe_%DATE%_log.txt"
@echo (c) Neokobe.nl (info@neokobe.nl) May 2004 >> "sourcesafe_%DATE%_log.txt"
@echo %time% - Starting sourcesafe backup >> "sourcesafe_%DATE%_log.txt"
@echo %time% - Using account: %ssuser% >> "sourcesafe_%DATE%_log.txt"
@echo %time% - Using SourceSafe database: %ssdir% >> "sourcesafe_%DATE%_log.txt" 
@echo %time% - Using backup directory: "%ssbakd%" >> "sourcesafe_%DATE%_log.txt" 
@echo %time% - Log directory: %thisDir% >> "sourcesafe_%DATE%_log.txt" 
@echo ======================================================= >> "sourcesafe_%DATE%_log.txt"

REM --------------------------------------------------------
REM Set SourceSafe working folder to backup directory
REM --------------------------------------------------------
@ss Workfold $/ %ssbakd% -Y%ssuser%,%sspass% -Oworkfold.txt
FOR /F "delims= " %%e IN ('TYPE workfold.txt') DO IF "%%e"=="Invalid" GOTO WorkFoldError
DEL /Q workfold.txt

REM --------------------------------------------------------
REM Get latest versions of all project files recursively
REM --------------------------------------------------------
@ss Get $/* -R -I-Y -Y%ssuser%,%sspass% -Oget.txt
FOR /F "delims= " %%e IN ('TYPE get.txt') DO IF "%%e"=="Invalid" GOTO GetError
DEL /Q get.txt

@echo "" >> "sourcesafe_%DATE%_log.txt"
DIR %ssbakd% | FIND "Dir(s)" >> "sourcesafe_%DATE%_log.txt"
@echo %time% - Finished sourcesafe backup >> "sourcesafe_%DATE%_log.txt"
GOTO FinishUp

REM --------------------------------------------------------
REM Send logfile by e-mail
REM --------------------------------------------------------

:WorkFoldError
@echo Error occured while setting working folder: >> "sourcesafe_%DATE%_log.txt"
TYPE workfold.txt >> "sourcesafe_%DATE%_log.txt"
DEL /Q workfold.txt
GOTO SendMail

:GetError
@echo Error occured while getting project files: >> "sourcesafe_%DATE%_log.txt"
TYPE get.txt >> "sourcesafe_%DATE%_log.txt"
DEL /Q get.txt

:SendMail
IF "%ssmail%"=="" GOTO FinishUp
IF "%smtp%"=="" GOTO FinishUp

@echo Dim mail > mailscript.vbs
@echo Dim conf >> mailscript.vbs
@echo Dim smtpserver >> mailscript.vbs 
@echo Dim Flds >> mailscript.vbs 
@echo Set mail = CreateObject("CDO.Message") >> mailscript.vbs 
@echo Set conf = CreateObject("CDO.Configuration") >> mailscript.vbs
@echo Set Flds = conf.Fields >> mailscript.vbs
@echo With Flds >> mailscript.vbs
@echo   .Item("http://schemas.microsoft.com/cdo/configuration/sendusing") = 2 >> mailscript.vbs
@echo   .Item("http://schemas.microsoft.com/cdo/configuration/smtpserver") = "%smtp%" >> mailscript.vbs
@echo   .Update >> mailscript.vbs
@echo End with >> mailscript.vbs
@echo mail.Configuration = conf >> mailscript.vbs
@echo mail.HTMLBody = "Attached is the SourceSafe backup script logfile." >> mailscript.vbs
@echo mail.AddAttachment "%thisDir%\sourcesafe_%DATE%_log.txt" >> mailscript.vbs
@echo mail.From = """SourceSafe backup script"" <%ssmail%>" >> mailscript.vbs 
@echo mail.Subject ="SourceSafe backup script ERROR" >> mailscript.vbs 
@echo mail.To = "%ssmail%" >> mailscript.vbs 
@echo mail.Send >> mailscript.vbs

@mailscript.vbs
DEL /Q mailscript.vbs

REM --------------------------------------------------------
REM Finishing up
REM --------------------------------------------------------

:FinishUp
@echo %time%: Finished backup
@echo on